unit main;

interface

uses
  Forms, BFBaseComponent, BFClient, Dialogs, ComCtrls, StdCtrls, Classes,
  Controls;

type
  TfmMain = class(TForm)
    ListView: TListView;
    Button1: TButton;
    Button2: TButton;
    ProgressBar1: TProgressBar;
    OpenDialog: TOpenDialog;
    BFObjectPushClient: TBFObjectPushClient;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BFObjectPushClientProgress(Sender: TObject; ObjectName: String; ObjectIndex, ObjectTotal, Position, Size: Cardinal; var Abort: Boolean);
    procedure Button3Click(Sender: TObject);

  private
    FAbort: Boolean;
  end;

var
  fmMain: TfmMain = nil;

implementation

uses
  BFAPI, DevSel, SysUtils;

{$R *.dfm}

procedure TfmMain.Button1Click(Sender: TObject);
var
  Loop: Integer;
begin
  if OpenDialog.Execute then
    with ListView.Items do begin
      BeginUpdate;
      for Loop := 0 to OpenDialog.Files.Count - 1 do
        with Add do
          Caption := OpenDialog.Files[Loop];
      EndUpdate;
    end;
end;

procedure TfmMain.Button2Click(Sender: TObject);
var
  Loop: Integer;
  DoOpen: Boolean;
begin
  DoOpen := False;

  with TfmDevSel.Create(Self) do begin
    if ShowModal = mrOK then begin
      DoOpen := True;

      with BFObjectPushClient do
        case PageControl.ActivePageIndex of
          0: begin
               Transport := btBluetooth;
               BluetoothTransport.Address := edBluetoothAddress.Text;
             end;

          1: begin
               Transport := btIrDA;
               IrDATransport.Address := edIrDAAddress.Text;
             end;

          2: begin
               Transport := btCOMPort;
               COMPortTransport.Port := StrToInt(edPort.Text);
               COMPortTransport.InitCommand := edInitString.Text;
             end;
        end;
    end;

    Free;
  end;

  if DoOpen then begin
    BFObjectPushClient.Open;
    FAbort := False;

    for Loop := 0 to ListView.Items.Count - 1 do begin
      ListView.Items[Loop].Checked := True;
      BFObjectPushClient.Put(ListView.Items[Loop].Caption);
    end;

    BFObjectPushClient.Close;
  end;
end;

procedure TfmMain.BFObjectPushClientProgress(Sender: TObject; ObjectName: String; ObjectIndex, ObjectTotal, Position, Size: Cardinal; var Abort: Boolean);
begin
  ProgressBar1.Max := Size;
  ProgressBar1.Position := Position;
  Update;
  Application.ProcessMessages;
  Abort := FAbort;
end;

procedure TfmMain.Button3Click(Sender: TObject);
begin
  FAbort := True;
end;

end.
